----------------------------------------------------------------------------
--                                  M2OS
--
--                           Copyright (C) 2019
--                    Universidad de Cantabria, SPAIN
--
--  Author: Mario Aldea Rivas (aldeam@unican.es)
--
--  This file is part of M2OS.
--
--  M2OS is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  M2OS is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with M2OS.  If not, see <https://www.gnu.org/licenses/>.
----------------------------------------------------------------------------

with System;
with M2.HAL;

package AdaX_Dispatching_Stack_Sharing is
   
   type Initialization_Ac is access procedure;
   subtype Job_Body_Ac is M2.HAL.Procedure_Ac;

   task type One_Shot_Task (Init_Ac  : Initialization_Ac;
                            Body_Ac  : Job_Body_Ac;
                            Priority : System.Priority) with
     Priority => Priority,
#if M2_TARGET = "arduino_uno" then
       Storage_Size => 0; --  There is no individual stack for each task
#elsif M2_TARGET = "stm32f4" or M2_TARGET = "epiphany" or M2_TARGET = "avr_iot" then
       Storage_Size => 0, --  There is no individual stack for each task
       Secondary_Stack_Size => 0;  
#else
   pragma Compile_Time_Error (True, "Unexpected architecture");
#end if;

end AdaX_Dispatching_Stack_Sharing;
