----------------------------------------------------------------------------
--                                  M2OS
--
--                           Copyright (C) 2019
--                    Universidad de Cantabria, SPAIN
--
--  Author: Mario Aldea Rivas (aldeam@unican.es)
--
--  This file is part of M2OS.
--
--  M2OS is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  M2OS is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with M2OS.  If not, see <https://www.gnu.org/licenses/>.
----------------------------------------------------------------------------
pragma Restrictions (No_Elaboration_Code);

with System;
with Interfaces;

with GNAT.IO;

package M2.Direct_IO is
   --  pragma Pure;
   pragma Preelaborate;

   procedure Put (Str : String) renames GNAT.IO.Put;

   procedure Put_Line (Str : String) renames GNAT.IO.Put_Line;

   procedure Put (Num : Integer; Base : Positive := 10);

   procedure Put_Null_Terminated (Str_Ad : System.Address);

--   procedure Put (D : Duration);

   procedure PutChar (C : Character) renames GNAT.IO.Put;

   procedure New_Line;

--   procedure Change_Device (Write_Function : Drivers.Write_Function_Ac);

   procedure Initialization;

end M2.Direct_IO;
