----------------------------------------------------------------------------
--                                  M2OS
--
--                           Copyright (C) 2019
--                    Universidad de Cantabria, SPAIN
--
--  Author: Mario Aldea Rivas (aldeam@unican.es)
--
--  This file is part of M2OS.
--
--  M2OS is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  M2OS is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with M2OS.  If not, see <https://www.gnu.org/licenses/>.
----------------------------------------------------------------------------
package M2.Queue_Implementation is
   pragma Preelaborate;

   type Base_Element is record
      Next : access Base_Element;
   end record with Alignment => Standard'Maximum_Alignment;
   --type Base_Element is private;
   type Base_Element_Ac is access all Base_Element;
   type Queue_Ac is access all Base_Element_Ac;

   type Mayor_Than_Function_Ac is
     access function (Left, Right : access Base_Element) return Boolean;

   procedure Enqueue (E : Base_Element_Ac;
                      Q : Queue_Ac;
                      Mayor_Than : Mayor_Than_Function_Ac);
   --  {Pre: E not in Q}

   procedure Dequeue (E : Base_Element_Ac;
                      Q : Queue_Ac);
   --  {Pre: E is in Q}

   procedure Dequeue_Head (Q : Queue_Ac) with Inline_Always;
   --  {Pre: Q is not empty}

end M2.Queue_Implementation;
