----------------------------------------------------------------------------
--                                  M2OS
--
--                           Copyright (C) 2019
--                    Universidad de Cantabria, SPAIN
--
--  Author: Mario Aldea Rivas (aldeam@unican.es)
--
--  This file is part of M2OS.
--
--  M2OS is free software: you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  M2OS is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with M2OS.  If not, see <https://www.gnu.org/licenses/>.
----------------------------------------------------------------------------

pragma Restrictions (No_Elaboration_Code);

pragma Discard_Names;

with System.Storage_Elements;

package M2 is
   pragma Pure;
   --  pragma No_Elaboration_Code_All;

--     pragma Compile_Time_Error (System.Address'Size /= 16,
--                                "Address'size /= 16");
--     pragma Compile_Time_Error (Integer'Size /= 16,
--                                "Integer'size /= 16");
--     pragma Compile_Time_Error (Natural'Size /= 15,
--                                "Natural'size /= 15");
--     pragma Compile_Time_Error (Positive'Size /= 15,
--                                "Positive'size /= 15");

   Priority_Max : constant := 31;

   Num_User_Tasks_Max : constant := 5;
   --  Maximum number of user's threads.

   type Trace_Levels is (Warning, Trace);

   Trace_Enabled : constant array (Trace_Levels) of Boolean :=
     (Warning => True,
      Trace   => False);

   --  Dynamic_Memory_Pool_Size_In_Bytes : constant := 128;

   type Use_Timing_Events is new Boolean range True .. True;
   type Allow_Timing_Events_Cancellation is new Boolean range True .. True;

   ---------------------
   -- Integer_Address --
   ---------------------

   subtype Integer_Address is System.Storage_Elements.Integer_Address;
   --  Shortcut for this extesively used type
   function To_Address (Value : Integer_Address) return System.Address
     renames System.Storage_Elements.To_Address;
   function To_Integer (Value : System.Address) return Integer_Address
     renames System.Storage_Elements.To_Integer;
--     pragma Compile_Time_Error (Integer_Address'Size /= 16,
--                                "Integer_Address'size /= 16");

end M2;
